import java.awt.*;
import java.awt.image.*;
import java.util.*;
import java.io.*;
import javax.imageio.*;
 
 
public class ImageCanvas extends Canvas {
  BufferedImage image;
   ImageCanvas(){image=null;}
   ImageCanvas(String name) {
     try {
    image = ImageIO.read(new File(name));
	} catch (IOException e) {
		System.err.println(e.toString()+" can not open "+name);
	}

    }

   public Dimension getPreferredSize() {
        if (image == null) {
             return new Dimension(300,300);
        } else {
           return new Dimension(image.getWidth(null)+100, image.getHeight(null)+100);
       }
    }


  public void paint(Graphics g) {
    g.drawString("Painting", 10, 10);
      
     if (image==null){ g.drawString("null image",100,100);}
     else g.drawImage(image, 50,50, null);
    }

   public static void main(String argv[])throws InterruptedException {
    if (argv.length < 1) {
       System.out.println
          ("usage: ImageCanvas.class [image file name]");
       System.exit(0);
       }
    Frame frame = new Frame(argv[0]);
    frame.setLayout(new BorderLayout());
    frame.add("Center", new ImageCanvas(argv[0]));
     frame.pack();
    frame.setVisible(true);
    Thread.sleep(8000);
	System.exit(0);

    }

   }
