import java.awt.*;
import java.awt.image.*;
import java.util.*;
import java.io.*;
import javax.imageio.*;
 
 
public class RGBCanvas extends Canvas {
  BufferedImage image,R,G,B;int h,w;
	RGBCanvas( ){ }
   RGBCanvas(String name) {
     try {
    		image = ImageIO.read(new File(name));
		  w=image.getWidth(null);  h=image.getHeight(null);
		R= new BufferedImage(w,h,R. TYPE_INT_RGB );
		G= new BufferedImage(w,h,R. TYPE_INT_RGB );
		B= new BufferedImage(w,h,R. TYPE_INT_RGB );
		for(int x=0;x<w;x++)
		for(int y=0;y<h;y++)
		{
			/* Format of a pixel 
			Number of bits:        32
 			Red mask:              0x00ff0000
 			Green mask:            0x0000ff00
 			Blue mask:             0x000000ff
			*/
			R.setRGB(x,y,image.getRGB(x,y) & 0x00ff0000);
			G.setRGB(x,y,image.getRGB(x,y) & 0x0000ff00);
			B.setRGB(x,y,image.getRGB(x,y) & 0x000000ff);
		}
	} catch (IOException e) {
		System.err.println(e.toString()+" can not open "+name);
	}		

    }

   public Dimension getPreferredSize() {
        if (image == null) {
             return new Dimension(300,300);
        } else {
           return new Dimension(2*w+100,2* h+100);
       }
    }


  public void paint(Graphics g) {
    g.drawString("Painting", 10, 10);
      
     if (image==null){ g.drawString("null image",100,100);}
     else{ 
		g.drawImage(image, 50,50, null);
		g.drawImage(R, 50+w,50, null);
		g.drawImage(G, 50+w,50+h, null);
		g.drawImage(B, 50,50+h, null);
	}
    }

   public static void main(String argv[])throws InterruptedException {
    if (argv.length < 1) {
       System.out.println
          ("usage: ImageCanvas.class [image file name]");
       System.exit(0);
       }
    Frame frame = new Frame(argv[0]);
    frame.setLayout(new BorderLayout());
    frame.add("Center", new RGBCanvas(argv[0]));
     frame.pack();
    frame.setVisible(true);
    Thread.sleep(10000);
	System.exit(0);

    }

   }
